unit former;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,LDefin2D, ksConstTLB, ksAuto, ksTLB;

type
  TMainForm = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit4: TEdit;
    Button2: TButton;
    Button3: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

uses main;

{$R *.dfm}


procedure DrawBusher(x0,y0:double; nm:string; D1,D2,L:double);

// D1 -  ; D2 -  ; L -  
// x0,y0 -     ; mn -  

procedure MakeView(x0,y0:DOUBLE; nm:STRING);

var par:ksViewParam;
    n:INTEGER;

begin
 par := ksViewParam( kompas.GetParamStruct(ko_ViewParam) );
 with par do
  begin
   Init;
   //   
   x      := x0;
   y      := y0;
   scale_ := 1;
   Angle  := 0;
   //  ,   
   Color  := clRed;
   state  := stACTIVE;
   name   := nm
  end;
  n:=0;
  iDocument2D.ksCreateSheetView( par, n )
end;

procedure Stamp(c:byte; t:string);
var
  stamp     : ksStamp;
  itemParam : ksTextItemParam;

begin
 //     
 stamp := ksStamp( iDocument2d.GetStamp );
 itemParam := ksTextItemParam( kompas.GetParamStruct(ko_TextItemParam) );
 itemParam.Init;
 //    
 if stamp.ksOpenStamp=0 then
  begin
   kompas.ksMessage('    ');
   Exit
  end;
  //    
  Stamp.ksColumnNumber(c);
  //       
  ItemParam.s := t;
  Stamp.ksTextLine( ItemParam );
  //   
  stamp.ksCloseStamp
end;



procedure Contour;

begin
 iDocument2D.ksLineSeg(0,D2-(D2-D1)/2,L,D2-(D2-D1)/2,1);
 iDocument2D.ksLineSeg(0,D2-(D2-D1)/2,0,d2,1);
 iDocument2D.ksLineSeg(L,D2-(D2-D1)/2,L,d2,1);
 iDocument2D.ksLineSeg(0,D2,L,D2,1)
end;

procedure LinDim(x1,y1,x2,y2,dx,dy:DOUBLE; diamsign:boolean; pl1,pl2:boolean);

//   
// x1,y2,x2,y2 -    
// dx,dy -      x1,x2
// diamsign -    
// pl1, pl2 -       

var
  param   : ksLDimParam;
  dPar    : ksDimDrawingParam;
  sPar    : ksLDimSourceParam;
  tPar    : ksDimTextParam;
  str     : ksChar255;
  arrText : ksDynamicArray;

begin
  //    
  param := ksLDimParam( kompas.GetParamStruct(ko_LDimParam) );
  //   
  dPar := ksDimDrawingParam( param.GetDPar );
  //   
  sPar := ksLDimSourceParam( param.GetSPar );
  //   
  tPar := ksDimTextParam   ( param.GetTPar );
  dPar.Init;
  dPar.textBase := 0;  //   
  dPar.pt1      := 1; //    (1-, 2-)
  dPar.pt2      := 1; //   
  // /.  
  dPar.pl1      :=not(pl1);
  dPar.pl2      :=not(pl2);
  dPar.ang      := 0; //   
  dPar.lenght   := 0; //  
  sPar.Init;
  //    
  sPar.x1 := x1;
  sPar.y1 := y1;
  //    
  sPar.x2 := x2;
  sPar.y2 := y2;
  //   
  sPar.dx := dx;
  sPar.dy := dy; {20}
  //     : 1 -  1,y1,
  // 2 -  x2,y2
  sPar.basePoint := 1;
  tPar.Init( False );
  //  
  tPar.SetBitFlagValue( _AUTONOMINAL, true );
  if diamsign then
   tPar.sign := 1;
  //  
  iDocument2d.ksLinDimension( param )
end;

begin
 //  
 MakeView(x0,y0,nm);
 //  
 iDocument2D.ksLineSeg(-5,d2/2,L+5,d2/2,3);
 //  
 iDocument2D.ksLineSeg(0,0,l,0,1);
 iDocument2D.ksLineSeg(0,0,0,D2-(D2-D1)/2,1);
 iDocument2D.ksLineSeg(L,0,L,D2-(D2-D1)/2,1);
 Contour;
 // 
 iDocument2D.ksHatch(0,45,1,5,5,D2-(D2-D1)/2+5);
 Contour;
 iDocument2D.ksEndObj;
 // 
 LinDim(0,0,L,0,0,-20,false,true,true);
 //  
 LinDim(0,0,0,d2,-20,0,true,true,true);
 //  
 LinDim(0,(D2-D1)/2,0,(D2-D1)/2+d1,-10,0,true,false,true);
 //  
 Stamp(1,'');
 Stamp(3,' 40');
 Stamp(9,'');
 Stamp(8,'1');
 Stamp(110,' ..');
 Stamp(130,DateToStr(Now))
end;

procedure TMainForm.Button3Click(Sender: TObject);

var d1,d2,l:double;

begin
 try
  d1:=StrToFloat(Edit1.Text);
  d2:=StrToFloat(Edit2.Text);
  l:=StrToFloat(Edit4.Text)
 except
  Kompas.ksMessage(' ');
  abort
 end;
 if D2>=d1 then
  begin
   Kompas.ksMessage('   ');
   abort
 end;
 DrawBusher(100,100, 'busher',d2, d1, l)
end;

end.

